/**************/
/* kolmio.c   */
/****************************************************************************/
/*
** Malliohjelma kauan kestvst piirtmisest.
** Piirretn rekursiivisesti joukko kolmioita.
**
** Vesa Lappalainen 16.8.1992
**
** Kntminen:
**  Tee projektio kolmio.prj:
**     samplew.c
**     kolmio.c
**     ???\ali\timer.c
**     samplew.def
**
** Tehtvi 1)  Kokeile piirtmisen aikana valita ikkunan suurennus tms. tai
**              paina vaikkapa kahdesti (molemmat vlill irti) ALT-TAB.
**              Sd ohjelman suoritusaikaa muuttelemalla vakiota
**              PIENIN_KOLMIO (pieni->kauan, iso-> nopea).
**              Mik vika on ohjelmassa?
**
**              Kynnist samanaikaisesti jokin toinen ohjelma ja sd sen
**              ikkunan niin pieneksi, ettei se peit kuin osaksi "Kolmiot"
**              ikkunaa.  Laita sitten ikkunoiden jrjestys siten, ett
**              "Kolmiot"-ikkuna on toiseksi ylin ja avaamasi pikku-ikkuna
**              on ylimpn.  Siirtele pikkuikkunaa kolmiot ikkunan pll!
**
**          2)  Ohjelmaikkunan otsikkoksi muuttuu aika, jonka ikkunan uudelleen
**              piirtminen vei.  Kokeile peitt ikkunaa eri tavoin toisella
**              ikkunalla ja koeta keksi syy, miksi uudelleen piirto vie
**              eri ajan peiton suuruudesta riippuen.
**
**              Kokeile samaa siten, ett prohjektsissa on samplew.c:n tilalla
**              samplew2.c.  Muuttuuko uudelleen piirron aika nyt?
**
**          3)  Ohjelmaan liittyy mys "hp-hp"-piirtminen.  Miten luulet
**              piirtmisen toimivan?  Ky vlill toisessa ikkunassa ja
**              palaa takaisin ohjelmaan.  Mit ky piirroksille?
**
**          4)  Muuta "piirtminen" sellaiseksi, ett kun hiiren nappi
**              painetaan alas, aletaan piirt murtoviivaa kunnes
**              nappi pstetn yls.  Mit tapahtuu kun nappi
**              pstetnkin yls "Kolmiot"-ikkunan ulkopuolella ja
**              sitten tuodaan hiiri takaisin ikkunan sislle nappi
**              ylhll?
**
**          5)  Miten "Piirtminen" pitisi muuttaa, jotta kuva korjautuisi
**              toisessa ikkunassa kymisen jlkeen?
**
----------------------------------------------------------------------------*/
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "timer.h"

char *WindowName = "Kolmio";

#define PIENIN_KOLMIO 20   /* Sd tll kauanko koko kuvan piirt. kest.  */

#define I(x,y) hdc,((int)(x)),((int)(y))


/****************************************************************************/
void kolmio(HDC hdc, double x, double y, double h)
{
  double s2 = h / (sqrt(3));

  MoveTo(I(x,y));
  LineTo(I(x-s2,y-h));
  LineTo(I(x+s2,y-h));
  LineTo(I(x,y));

  if ( h < PIENIN_KOLMIO ) return;

  kolmio(hdc,x-s2,y,h/2);  /* Pienempi kolmio vasemmalle */
  kolmio(hdc,x+s2,y,h/2);  /* Pienempi kolmio oikealle   */
  kolmio(hdc,x,y-h,h/2);   /* Pienempi kolmio ylpuolelle*/
}


/****************************************************************************/
void MyDraw(HWND hWnd,HDC hDC)
{
  char s[100];

  SetWindowText(hWnd,"Kolmio: Piirretn...");

  start_timer(1);

  kolmio(hDC,300,400,200);

  sprintf(s,"Kolmio: %5.2lf s.",stop_timer(1));

  SetWindowText(hWnd,s);
}


/****************************************************************************/
/*
** Seuraavissa aliohjelmissa on seuraavat parametrit:
**
**   hWnd     - ikkunan kahva
**   wParam   - SHIFT, CTRL ja ALT -nppimen tile, voidaan testata esim.
**                 if ( wParam && MK_CONTROL ) ... hommat jos CTRL alhaalla
**   lParam   - x = LOWORD(lParam) ja y = HIWORD(lParam)
**              ktevmpi on kuitenkin selvitt hiren paikka:
**               POINT pt = MAKEPOINT(lParam)
**
----------------------------------------------------------------------------*/

static POINT old = {0,0};
static pen_down  = 0;

/****************************************************************************/
void MyDown(HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiren nappa on painettu alas                  */
{
#pragma argsused
  old = MAKEPOINTS(lParam);
  pen_down = 1;
}


/****************************************************************************/
void MyUp  (HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiren nappi on pstetty yls                 */
{
#pragma argsused
  pen_down = 0;
}


/****************************************************************************/
void MyMove(HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiri on liikkunut                             */
{
#pragma argsused
  HDC     hDC;
  POINT pt = MAKEPOINTS(lParam);

  if ( !pen_down ) return;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  MoveTo(hDC,old.x,old.y);
  LineTo(hDC,pt.x,pt.y);

  ReleaseDC(hWnd,hDC);
}