
/****************************************************************************/
/*
** Malliohjelma kauan kestvst piirtmisest.
** Piirretn rekursiivisesti joukko kolmioita.
**
** Vesa Lappalainen 16.8.1992
**
** Kntminen:
**  Tee projektio kolmio.prj:
**     sample.c
**     kolmio.c
**     sample.def
**
** Tehtvi 1)  Kokeile piirtmisen aikana valita ikkunan suurennus tms. tai
**              paina vaikkapa kahdesti (molemmat vlill irti) ALT-TAB.
**              Sd ohjelman suoritusaikaa muuttelemalla vakiota
**              PIENIN_KOLMIO (pieni->kauan, iso-> nopea).
**              Mik vika on ohjelmassa?
**
**              Kynnist samanaikaisesti jokin toinen ohjelma ja sd sen
**              ikkunan niin pieneksi, ettei se peit kuin osaksi "Kolmiot"
**              ikkunaa.  Liata sitten ikkunoiden jrjestys siten, ett
**              "Kolmiot"-ikkuna on toiseksi ylin ja avaamasi pikku-ikkuna
**              on ylimpn.  Siirtele pikkuikkunaa kolmiot ikkunan pll!
**
**          2)  Ohjelmaan liittyy mys "hp-hp"-piirtminen.  Miten luulet
**              piirtmisen toimivan?  Ky vlill toisessa ikkunassa ja
**              palaa takaisin ohjelmaan.  Mit ky piirroksille?
**
**          3)  Muuta "piirtminen" sellaiseksi, ett kun hiiren nappi
**              painetaan alas, aletaan piirt murtoviivaa kunnes
**              nappi pstetn yls.  Mit tapahtuu kun nappi
**              pstetnkin yls "Kolmiot"-ikkunan ulkopuolella ja
**              sitten tuodaan hiiri takaisin ikkunan sislle nappi
**              ylhll?
**
**          4)  Miten "Piirtminen" pitisi muuttaa, jotta kuva korjautuisi
**              toisessa ikkunassa kymisen jlkeen?
**
----------------------------------------------------------------------------*/
#include <windows.h>
#include <math.h>
#include "timer.h"

static int stop = 0;

/****************************************************************************/
int CheckMessage(void)
{
  MSG msg;
  int i=0;
  if ( stop ) return 1;
  while ( PeekMessage(&msg,NULL,0,0,PM_REMOVE | PM_NOYIELD) ) {
    switch ( msg.message ) {
      case WM_PAINT:
        return 0;
      case WM_QUIT:
        stop = 1;
        return 1;
    }
#if 1
    TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit   */
    DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle          */
    stop = 0;
#endif
    i = 0;
  }
/*
  return 0;
*/
  return i;
}

char *WindowName = "Kolmiot";

#define PIENIN_KOLMIO 2   /* Sd tll kauanko koko kuvan piirt. kest.  */

#define I(x,y) hdc,((int)(x)),((int)(y))


/****************************************************************************/
void kolmio(HDC hdc, double x, double y, double h)
{
  double s2 = h / (sqrt(3));

  if ( CheckMessage() ) return; 

  MoveTo(I(x,y));
  LineTo(I(x-s2,y-h));
  LineTo(I(x+s2,y-h));
  LineTo(I(x,y));

  if ( h < PIENIN_KOLMIO ) return;

  kolmio(hdc,x-s2,y,h/2);  /* Pienempi kolmio vasemmalle */
  kolmio(hdc,x+s2,y,h/2);  /* Pienempi kolmio oikealle   */
  kolmio(hdc,x,y-h,h/2);   /* Pienempi kolmio ylpuolelle*/
}


/****************************************************************************/
void MyDraw(HWND hWnd)
{
  PAINTSTRUCT ps;

  stop = 0;

  SetWindowText(hWnd,"Piiretn...");

  BeginPaint(hWnd,&ps);

  start_timer(1);

  kolmio(ps.hdc,300,400,200);

  SetWindowText(hWnd,stop_timer(1));

  EndPaint(hWnd,&ps);
}


/****************************************************************************/
/*
** Seuraavissa aliohjelmissa on seuraavat parametrit:
**
**   hWnd     - ikkunan kahva
**   wParam   - SHIFT, CTRL ja ALT -nppimen tile, voidaan testata esim.
**                 if ( wParam && MK_CONTROL ) ... hommat jos CTRL alhaalla
**   lParam   - x = LOWORD(lParam) ja y = HIWORD(lParam)
**              ktevmpi on kuitenkin selvitt hiren paikka:
**               POINT pt = MAKEPOINT(lParam) 
**
----------------------------------------------------------------------------*/

static POINT old = {0,0};
static pen_down  = 0;

/****************************************************************************/
void MyDown(HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiren nappa on painettu alas                  */
{
  old = MAKEPOINT(lParam);
  pen_down = 1;
  if (hWnd || wParam || lParam);
}


/****************************************************************************/
void MyUp  (HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiren nappi on pstetty yls                 */
{
  pen_down = 0;
  if (hWnd || wParam || lParam);
}


/****************************************************************************/
void MyMove(HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiri on liikkunut                             */
{
  HDC     hDC;
  POINT pt = MAKEPOINT(lParam);

  if (wParam || lParam);

  if ( !pen_down ) return;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  MoveTo(hDC,old.x,old.y);
  LineTo(hDC,pt.x,pt.y);

  ReleaseDC(hWnd,hDC);
}
