/**************/
/* samplew.c  */
/*****************************************************************************
    PROGRAM: samplew.c
    PURPOSE: Runko yksinkertaisille Windows-ohjelmille.
               Kirjoitetaan tiedosto, jossa on funktiot
                 MyMove   (kun hiiri liikkunut)
                 MyDown   (kun hiiren nppin alhaalla)
                 MyUp     (kun hiiren nappi pstetty yls) ja
                 MyDraw   (vaikkapa tiedostoon myown.c)
               sek merkkijono
                 WindowName
               ja tehdn projekti, jossa on tiedostot
                 samplew.c
                 myown.c
                 samplew.def
               ja knnetn!  Siin se!

    Editor:  Vesa Lappalainen 15.8.1992
*****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa  */

#define MAINWNAME "SampleWClass" /* Tunniste, jolla ikkunaluokka tunnetaan  */

extern char *WindowName;
extern void MyDraw(HWND hWnd, HDC hDC);
extern void MyDown(HWND hWnd, WORD wParam, LONG lParam);
extern void MyUp  (HWND hWnd, WORD wParam, LONG lParam);
extern void MyMove(HWND hWnd, WORD wParam, LONG lParam);

/****************************************************************************/
LONG CALLBACK _export MainWndProc(HWND hWnd, UINT message,
                                  WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;

    switch (message)
    {
        case WM_PAINT:            /* Viesti: Piirr ikkuna uudelleen        */
           if ( BeginPaint(hWnd,&ps) )
               MyDraw(hWnd,ps.hdc);
             EndPaint(hWnd,&ps);
           return (NULL);

        case WM_LBUTTONDOWN:      /* Hiiren vasen nappi alas:               */
           MyDown(hWnd,wParam,lParam);
           return (NULL);

        case WM_LBUTTONUP:        /* Hiiren vasen nappi yls:               */
           MyUp(hWnd,wParam,lParam);
           return (NULL);

        case WM_MOUSEMOVE :       /* Hiirt siirretty:                      */
           MyMove(hWnd,wParam,lParam);
           return (NULL);

        case WM_DESTROY:          /* Viesti: ikkuna hvitetn              */
            PostQuitMessage(0);
            return (NULL);

        default:                  /* Antaa Windowsin ksitell muut         */
            break;
    }
    return (DefWindowProc(hWnd, message, wParam, lParam));
}

/****************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS  wc;   /* Ikkunaluokka                                         */
    HWND    hWnd;   /* Pikkunan kahva                                     */
    MSG msg;        /* Viesti                                               */
    (void)lpCmdLine;/* Hmyst, jottei valitusta param. kytt.             */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?        */
      wc.style         = NULL;           wc.lpfnWndProc    = MainWndProc;
      wc.cbClsExtra    = 0;              wc.cbWndExtra     = 0;
      wc.hInstance     = hInstance;
      wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground = GetStockObject(WHITE_BRUSH);
      wc.lpszMenuName  = NULL;           wc.lpszClassName  = MAINWNAME;
      if (!RegisterClass(&wc)) return (FALSE);
    }

    hWnd = CreateWindow(MAINWNAME,WindowName,WS_OVERLAPPEDWINDOW /* | CS_SAVEBITS */,
                        CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                     */
    UpdateWindow(hWnd);             /* Lhetetn WM_PAINT viesti           */

    while (GetMessage(&msg,NULL,NULL,NULL)) {
        TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit   */
        DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle          */
    }
    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo  */
}
