/**************/
/* kolmiom.c  */
/****************************************************************************/
/*
** Malliohjelma kauan kestvst piirtmisest.
** Piirretn rekursiivisesti joukko kolmioita.
**
** Vesa Lappalainen 16.8.1992
**
** Kntminen:
**  Tee projektio kolmiom.prj:
**     samplewm.c 
**       + ne jotka on sanottu samplewm.c:ssa
**     kolmiom.c
**     timer.c
**     samplewm.def
**
** Thn versioon on listty kolmionpiirto"silmukkaan" kutsu
**   CheckMessage, joka mahdollistaa moniajon.
**
** Tehtvi 1) Kokeile toimiiko muut ohjelmat nyt yhtaikaisesti piirron
**             kanssa.
**
**          2) Kokeile toimiiko ohjelman hiirell piirtminen kuvan
**             uudelleen piirron kanssa yhtaikaa.
**
**          3) Kirjoita ohjelma, joka "vritt" ikkunaan mustan nelin
**             vetmll siihen alekkaisia viivoja.
**             Toimiiko moniajossa?
**
----------------------------------------------------------------------------*/
#include <windows.h>
#include "samplewm.h"
#include <stdio.h>
#include <math.h>
#include "timer.h"

char *WindowName = "Kolmiom";

#define PIENIN_KOLMIO 0.5   /* Sd tll kauanko koko kuvan piirt. kest.  */

#define I(x,y) hdc,((int)(x)),((int)(y))


/****************************************************************************/
void kolmio(HDC hdc, double x, double y, double h)
{
  double s2 = h / (sqrt(3));

  if ( CheckMessage() ) return;  /* Tm mahdollistaa "moniajon"!!!!!!!!   */

  MoveTo(I(x,y));
  LineTo(I(x-s2,y-h));
  LineTo(I(x+s2,y-h));
  LineTo(I(x,y));

  if ( h < PIENIN_KOLMIO ) return;

  kolmio(hdc,x-s2,y,h/2);  /* Pienempi kolmio vasemmalle */
  kolmio(hdc,x+s2,y,h/2);  /* Pienempi kolmio oikealle   */
  kolmio(hdc,x,y-h,h/2);   /* Pienempi kolmio ylpuolelle*/
}


/****************************************************************************/
void MyDraw(HWND hWnd,HDC hDC)
{
  char s[100];

  SetWindowText(hWnd,"Kolmiom: Piirretn...");

  start_timer(1);

  kolmio(hDC,300,400,200);

  sprintf(s,"Kolmiom: %4.2lf s.",stop_timer(1));

  SetWindowText(hWnd,s);
}


/****************************************************************************/
/*
** Seuraavissa aliohjelmissa on seuraavat parametrit:
**
**   hWnd     - ikkunan kahva
**   wParam   - SHIFT, CTRL ja ALT -nppimen tile, voidaan testata esim.
**                 if ( wParam && MK_CONTROL ) ... hommat jos CTRL alhaalla
**   lParam   - x = LOWORD(lParam) ja y = HIWORD(lParam)
**              ktevmpi on kuitenkin selvitt hiren paikka:
**               POINT pt = MAKEPOINT(lParam)
**
----------------------------------------------------------------------------*/

static POINT old = {0,0};
static pen_down  = 0;

/****************************************************************************/
void MyDown(HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiren nappa on painettu alas                  */
{
#pragma argsused
  old = MAKEPOINT(lParam);
  pen_down = 1;
}


/****************************************************************************/
void MyUp  (HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiren nappi on pstetty yls                 */
{
#pragma argsused
  pen_down = 0;
}


/****************************************************************************/
void MyMove(HWND hWnd, WORD wParam, LONG lParam)
/* Aliohjelmaa kutsutaan kun hiiri on liikkunut                             */
{
#pragma argsused
  HDC     hDC;
  POINT pt = MAKEPOINT(lParam);

  if ( !pen_down ) return;

  if ( ( hDC = GetDC(hWnd) ) == NULL ) return;

  MoveTo(hDC,old.x,old.y);
  LineTo(hDC,pt.x,pt.y);

  ReleaseDC(hWnd,hDC);
}