/**************/
/* samplewm.c */
/*****************************************************************************
    PROGRAM: samplewm.c
    PURPOSE: Runko yksinkertaisille Windows-ohjelmille.
               Kirjoitetaan tiedosto, jossa on funktiot
                 MyMove   (kun hiiri liikkunut)
                 MyDown   (kun hiiren nppin alhaalla)
                 MyUp     (kun hiiren nappi pstetty yls) ja
                 MyDraw   (vaikkapa tiedostoon myown.c)
               sek merkkijono
                 WindowName
               ja tehdn projekti, jossa on tiedostot
                 samplewm.c
                 myown.c     (esimerkiksi)
                 samplew.def
                 checker.c
               mritelln NOT_PRINTER:
                 [Alt-O] C C [Alt-D] NOT_PRINTER [Return]
               ja knnetn!  Siin se!

    Thn versioon on listty viestijonon tarkistusaliohjelma, jonka avulla
    pitkt piirtosilmukat saadaan keskeytetyksi ja nin "moniajo" voi jatkua.
    Ohjelman kirjoittajan on listtv piirron pitkiin silmukoihin kutsu
      if ( CheckMessage() ) lopetetaan_piirto;


    Moniajon takia on listty kohdat jotka merkitty  MONIAJO!

    Kntmisess tytyy mritell NOT_PRINTER tai sitten list viel
    tulostus.c projektiin

    Editor:  Vesa Lappalainen 10.9.1992 & 19.7.1993
*****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa  */
#include "checker.h"                                            /* MONIAJO! */
#include "samplewm.h"

#define MAINWNAME "SampleWMClass" /* Tunniste, jolla ikkunaluokka tunnetaan */

/****************************************************************************/
LONG FAR PASCAL MainWndProcS(HWND hWnd, unsigned message, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;

    switch ( IsCheckingMessage(hWnd,message,wParam,lParam) ) {  /* MONIAJO! */
      case  1: return NULL;
      case -1: return DefWindowProc(hWnd, message, wParam, lParam);
    }

    switch (message)
    {
        case WM_PAINT:            /* Viesti: Piirr ikkuna uudelleen        */
           if ( BeginPaint(hWnd,&ps) ) {
               MyDraw(hWnd,ps.hdc);
               CheckEndPaint(hWnd,&ps);                         /* MONIAJO! */
           }
           return (NULL);


        case WM_LBUTTONDOWN:      /* Hiiren vasen nappi alas:               */
           MyDown(hWnd,wParam,lParam);
           return (NULL);

        case WM_LBUTTONUP:        /* Hiiren vasen nappi yls:               */
           MyUp(hWnd,wParam,lParam);
           return (NULL);

        case WM_MOUSEMOVE :       /* Hiirt siirretty:                      */
           MyMove(hWnd,wParam,lParam);
           return (NULL);

        case WM_DESTROY:          /* Viesti: ikkuna hvitetn              */
            PostQuitMessage(0);
            return (NULL);

        default:                  /* Antaa Windowsin ksitell muut         */
            break;
    }
    return (DefWindowProc(hWnd, message, wParam, lParam));
}

/****************************************************************************/
int PASCAL WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance,
                   LPSTR lpCmdLine, int nCmdShow)
{
#pragma argsused
    WNDCLASS  wc;   /* Ikkunaluokka                                         */
    HWND    hWnd;   /* Pikkunan kahva                                     */
    MSG msg;        /* Viesti                                               */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?        */
      wc.style         = NULL;           wc.lpfnWndProc    = MainWndProcS;
      wc.cbClsExtra    = 0;              wc.cbWndExtra     = 0;
      wc.hInstance     = hInstance;
      wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
      wc.hbrBackground = GetStockObject(WHITE_BRUSH);
      wc.lpszMenuName  = NULL;           wc.lpszClassName  = MAINWNAME;
      if (!RegisterClass(&wc)) return (FALSE);
    }

    hWnd = CreateWindow(MAINWNAME,WindowName,WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                     */
    UpdateWindow(hWnd);             /* Lhetetn WM_PAINT viesti           */

    while (GetMessage(&msg,NULL,NULL,NULL)) {
        TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit   */
        DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle          */
        CheckDelayMessages(hWnd);                               /* MONIAJO! */
    }
    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo  */
}