/****************************************************************************
    PROGRAM: Mhello.c
    PURPOSE: "Pienin Windows-ohjelma".  Tulostaa nyttn tekstin Hello World
    Editor:  Vesa Lappalainen  typistnyt malliohjelmista.
****************************************************************************/
#include <windows.h>            /* Tarvitaan kaikissa Windows C-ohjelmissa */
#include "savepos.h"

#define ININAME ".\\SAVETEST.INI"
#define SECTION "Paikka"
#define NAPPULA "Nappulan paikka"

#define MY_BUTTON 100

LONG FAR PASCAL MainWndProc(HWND hWnd, unsigned message, WPARAM wParam, LPARAM lParam)
{
    PAINTSTRUCT ps;

    switch (message)
    {
        case WM_CREATE:
            RestorePos(hWnd,ININAME,SECTION);
            break;

        case WM_PAINT:            /* Viesti: Piirr ikkuna uudelleen       */
            if ( BeginPaint(hWnd,&ps) )
              TextOut(ps.hdc, 10, 10, "Hello World!",12);
            EndPaint(hWnd,&ps);
            return (NULL);
        case WM_DESTROY:          /* Viesti: ikkuna hvitetn             */
            SavePos(GetDlgItem(hWnd,MY_BUTTON),ININAME,NAPPULA);
            SavePos(hWnd,ININAME,SECTION);
            PostQuitMessage(0);
            return (NULL);
        default:                  /* Antaa Windowsin ksitell muut        */
            break;
    }
    return (DefWindowProc(hWnd, message, wParam, lParam));
}

int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpCmdLine, int nCmdShow)
{
    WNDCLASS  wc;   /* Ikkunaluokka                                        */
    HWND    hWnd;   /* Pikkunan kahva                                    */
    HWND    hNWnd;
    MSG msg;        /* Viesti                                              */
    if (lpCmdLine); /* Hmyst, jottei valitusta param. kytt.            */

    if (!hPrevInstance) {       /* Onko muita esiintymi kynnisss?       */
      wc.style         = NULL;           wc.lpfnWndProc    = MainWndProc;   
      wc.cbClsExtra    = 0;              wc.cbWndExtra     = 0;              
      wc.hInstance     = hInstance;       
      wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION); 
      wc.hCursor       = LoadCursor(NULL, IDC_ARROW);   
      wc.hbrBackground = GetStockObject(WHITE_BRUSH); 
      wc.lpszMenuName  = NULL;           wc.lpszClassName  = "WHelloWClass";
      if (!RegisterClass(&wc)) return (FALSE);  
    }

    hWnd = CreateWindow("WHelloWClass","Windows Hello",WS_OVERLAPPEDWINDOW,
                        CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,CW_USEDEFAULT,       
                        NULL,NULL,hInstance,NULL);
    if (!hWnd) return (FALSE);
    ShowWindow(hWnd, nCmdShow);     /* Nytetn ikkuna                    */
    RestorePos(hWnd,ININAME,SECTION);
    UpdateWindow(hWnd);             /* Lhetetn WM_PAINT viesti          */

    hNWnd = CreateWindow("Button","Windows Hello",
                         WS_BORDER |WS_CHILD | WS_VISIBLE | WS_THICKFRAME,
                         10,30,100,30,hWnd,MY_BUTTON,hInstance,NULL);
    RestorePos(hNWnd,ININAME,NAPPULA);


    while (GetMessage(&msg,NULL,NULL,NULL)) {
        TranslateMessage(&msg);     /* Tulkitaan virtuaaliset np. koodit  */
        DispatchMessage(&msg);      /* Lhetetn viesti ikkunalle         */
    }
    return (msg.wParam);      /* Palautetaan PostQuitMessage-funktion arvo */
}