/* kolmiom.c */
/****************************************************************************/
/*
** Malliohjelma kauan kestvst piirtmisest.
** Piirretn rekursiivisesti joukko kolmioita.
**
** Vesa Lappalainen 16.8.1992 & 17.6.1994
**
** Kntminen:
**  Tee projekti kolmiom.prj:
**     kolmiom.c
**     simplet.def
**     ALI\timer.c
**     ALI\tabhand.c
**     ALI\checker.c
**
** Thn versioon on listty kolmionpiirto"silmukkaan" kutsu
**   CheckMessage, joka mahdollistaa moniajon. (Muutokset merkitty c)
**
**   "Hinta/s"   Win 3.1   WIN32
**  -----------------------------
**   Ilman       7.41      7.63
**   Kanssa      8.46      9.32
**
** Tehtvi 1) Kokeile toimiiko muut ohjelmat nyt yhtaikaisesti piirron
**             kanssa.
**
**          2) Kokeile toimiiko ohjelman hiirell piirtminen kuvan
**             uudelleen piirron kanssa yhtaikaa.
**
**          3) Kokeile voiko ohjelman lopettaa kesken piirron.
**             Poista _C -pohjelman esittelymakrosta ja kokeile mit
**             nyt tapahtuu.
**
**          4) Kirjoita ohjelma, joka "vritt" ikkunaan mustan nelin
**             vetmll siihen alekkaisia viivoja.
**             Toimiiko moniajossa?
**
----------------------------------------------------------------------------*/
#include <stdio.h>
#include <math.h>
#include "timer.h"
#include "tabhand.h"

/****************************************************************************/
TblClassSWindowMAIN_C("TriangleMClass",0,"Kolmiom",MsgTbl,0);          /* c */
/*                 ^^ */                                               /* c */
/****************************************************************************/

#define PIENIN_KOLMIO 0.07   /* Sd tll kauanko koko kuvan piirt. kest.  */

#define I(x,y) hdc,((int)(x)),((int)(y))   


/****************************************************************************/
void kolmio(HDC hdc, double x, double y, double h)
{
  double s2 = h / (sqrt(3));

  if ( CheckMessage() ) return;                                        /* c */

  MoveToEx(I(x,y),NULL);
  LineTo(I(x-s2,y-h));
  LineTo(I(x+s2,y-h));
  LineTo(I(x,y));

  if ( h < PIENIN_KOLMIO ) return;

  kolmio(hdc,x-s2,y,h/2);  /* Pienempi kolmio vasemmalle */
  kolmio(hdc,x+s2,y,h/2);  /* Pienempi kolmio oikealle   */
  kolmio(hdc,x,y-h,h/2);   /* Pienempi kolmio ylpuolelle*/
}


/****************************************************************************/
static EVENT WM_paint(tMSGParam *msg) /* # MAKE_DC # */
{
  char s[100];

  SetWindowText(msg->hWnd,"Kolmio: Piirretn...");

  start_timer(1);

  kolmio(msg->hDC,300,400,200);

  sprintf(s,"Kolmio: %5.2lf s.",stop_timer(1));

  SetWindowText(msg->hWnd,s);

  return 0;
}


/****************************************************************************/
/*
** Seuraavissa aliohjelmissa on seuraavat parametrit:
**
**   hWnd     - ikkunan kahva
**   wParam   - SHIFT, CTRL ja ALT -nppimen tile, voidaan testata esim.
**                 if ( wParam && MK_CONTROL ) ... hommat jos CTRL alhaalla
**   lParam   - x = LOWORD(lParam) ja y = HIWORD(lParam)
**              ktevmpi on kuitenkin selvitt hiiren paikka:
**               POINTS pt = MAKEPOINTS(lParam)
**
----------------------------------------------------------------------------*/

static POINTS old = {0,0};
static pen_down  = 0;

/****************************************************************************/
static EVENT WM_lbuttondown(tMSGParam *msg)  /* # MAKE_DC # */
/* Aliohjelmaa kutsutaan kun hiiren nappa on painettu alas                  */
{
  old = MAKEPOINTS(msg->lParam);
  pen_down = 1;
  return 0;
}


/****************************************************************************/
static EVENT WM_lbuttonup(tMSGParam *msg)
/* Aliohjelmaa kutsutaan kun hiiren nappi on pstetty yls                 */
{
#pragma argsused
  pen_down = 0;
  return 0;
}


/****************************************************************************/
static EVENT WM_mousemove(tMSGParam *msg) /* # MAKE_DC # */
/* Aliohjelmaa kutsutaan kun hiiri on liikkunut                             */
{
  POINTS pt = MAKEPOINTS(msg->lParam);

  if ( !pen_down ) return 0;

  MoveToEx(msg->hDC,old.x,old.y,NULL);
  LineTo(msg->hDC,pt.x,pt.y);
  return 0;
}

/****************************************************************************/
static EVENT WM_create(tMSGParam *msg)
/* Aliohjelmaa kutsutaan kun ikkuna on luotu, muttei viel nytss.        */
{
  MoveWindow(msg->hWnd,10,10,600,500,FALSE);
  return 0;
}


/****************************************************************************/
/* Viestien ksittelytaulukko                                               */
/****************************************************************************/
#define DoC DONT_CARE
tMSGEntry MsgTbl[] = {
  EV_HANDLE_WM_DESTROY,
  { WM_PAINT , DoC , DoC , WM_paint,  MAKE_DC  }, /*a*/
  { WM_LBUTTONDOWN , DoC , DoC , WM_lbuttondown,  MAKE_DC  }, /*a*/
  { WM_LBUTTONUP , DoC , DoC , WM_lbuttonup }, /*a*/
  { WM_MOUSEMOVE , DoC , DoC , WM_mousemove,  MAKE_DC  }, /*a*/
  { WM_CREATE , DoC , DoC , WM_create }, /*a*/
  { 0 }
};
/****************************************************************************/